
//==========================================================================//
//	Attend l'appui d'une touche et permet de supprimer la rptition de touche																				  							    			//
//	Option 1: ne fait rien tant qu'aucune touche n'est presse.
//	Option 2: teste une fois toutes les touches puis sort de la boucle. 
//==========================================================================//

#define NE_FAIT_RIEN		1
#define	TESTE_ET_SORT		2

void PressionTouche(short option)
{
	static unsigned char touche[10] = {}, vieille_t[10] = {};
	short tampon, rangee, APPS, MOINS, PLUS;
	long apd;
	char buffer[1];
  rangee = 0;
  apd = 0;
  
	do
	{
		rangee ++;
		rangee %= NUM_COL;
		tampon = vieille_t[rangee];
	  touche[rangee] = _rowread(~(1<<rangee));
	  vieille_t[rangee] = touche[rangee];
	  touche[rangee] &= ~tampon; 	
	  
		if(TI89)
	  {
	  	APPS = (touche[5] & 1);
	  	MOINS = (touche[1] & 4);
	  	PLUS = (touche[1] & 2);
	  }
	  else
	  {
	  	APPS = (touche[7] & 64);
	  	MOINS = (touche[9] & 1);
	  	PLUS = (touche[8] & 16);
	  }
		
		if((APPS || (apd ++) == 400000))
		{
			if(link)
			{
				buffer[0] = (char)(-1);
				OSWriteLinkBlock(buffer, 1);	// Ordonne  l'autre calc de s'teindre
				for(apd = 0; apd <= 3000; apd ++);	// Une mini boucle d'attente
			}			
			off();
			apd = 0;
			touche[rangee] = 0;
		}
		
		else if(MOINS)
		{
			OSContrastDn();
			apd = 0;
			touche[rangee] = 0;
		}
		
		else if (PLUS)
		{
			OSContrastUp();
			apd = 0;
			touche[rangee] = 0;
		}
		
	}while(option == 1 ? touche[rangee] == 0: rangee != 0);
	
	if(TI89)
	{ 
    HAUT	=	(touche[0] & 1);
    BAS = (touche[0] & 4);
    DROITE	= (touche[0] & 8);  
    GAUCHE	=	(touche[0] & 2);
    ENTER = (touche[1] & 1);
    ESCAPE = (touche[6] & 1);
    SECOND = (touche[0] & 16);
    SHIFT = (touche[0] & 32);
    DIAMAND = (touche[0] & 64);
  }
  else
  {
    HAUT	=	(touche[0] & 32);
    BAS = (touche[0] & 128);  
    DROITE	= (touche[0] & 64);
    GAUCHE	=	(touche[0] & 16);
    ENTER = ((touche[6] & 64) || (touche[9] & 2) || (touche[0] & 8)); // [ENTER1] ou [ENTER2] ou [HAND]
    ESCAPE = (touche[8] & 64);
    SECOND = (touche[6] & 16); // [F1]
    SHIFT = (touche[7] & 16); // [F5]
    DIAMAND = (touche[0] & 8); // [HAND]
  }
	
	// Je sais, j'aurais pu utiliser une macro comme celle-ci:
	// #define HAUT			(TI89? (touche[0] & 1): (touche[0] & 32))
	// ...
	// etc
	// mais cette mthode prends beaucoup plus de place :o)
}
//==========================================================================//